#include "project.h"
#include "tty_utils.h"

typedef void (*func_ptr)(void) ;

typedef struct _f_list_st_ {
    char *name ;
    func_ptr func ;
    char *description ;
} f_list_type ;

void do_help(void) ;
void do_lough(void) ;

f_list_type func_list[] = {
    { "help",  do_help,  "show help message"},
    { "lough", do_lough, "let MCU lough"},
    { 0,       0,        0 }
} ;

func_ptr get_func(char *cmd) 
{
    int i = 0 ;
    func_ptr ptr ;

    for (i = 0 ; func_list[i].name ; i++ ) {
        if (strcmp(func_list[i].name, cmd) == 0) {
            break ;
        }
    }
    ptr = func_list[i].func ;
    
    return( ptr ) ;
}

void do_command(char *cmd)
{
    func_ptr func ;
    
    func = get_func(cmd) ;
    if (func) {
        func() ;
    } else {
        do_help() ;
    }
}

void init_hardware() 
{
    CyGlobalIntEnable; /* Enable global interrupts. */
    tty_init() ;
}

int main(void)
{
    init_hardware() ;
    
    splash("5LP uart test") ;
    
    prompt() ;
    for(;;) {
        if (get_line()) {
            do_command(str) ;
            prompt() ;
        }
    }
}

void do_help(void)
{
    int i ;
    
    print("=== command ===\n\r") ;
    for (i = 0 ; func_list[i].name ; i++ ) {
        print(func_list[i].name) ;
        print(" : ") ;
        print(func_list[i].description) ;
        print("\n\r") ;
    }
    print("===============\n\r") ;
}

void do_lough(void)
{
    print("Ha ha ha ha!\n\r") ;
}
